'//Program:         Buttons.Bas
'//Description:     Creates a Windows95 Button
'//Created by:      Steven Castle aka PURE_POWER
'                   Reality Software
'                   RealitySoftware.multiservers.com

'//Extras:          Thx to qbwinfnt. QB Windows Font Maker/Loader
'                   Download it from our site.. files/other/


'Buttons
DECLARE SUB Button (id!, xStart!, yStart!, xEnd!, yEnd!, Text$)
DECLARE SUB Button.Animate (id!)
'Font
DECLARE SUB fopen (file$, file%)
DECLARE SUB fprint (Text$, Textx!, Texty!, Colour%, file%)

'Mouse
DECLARE SUB Mouse (a%, B%, c%, d%)
DECLARE SUB show ()
DECLARE SUB hide ()
DECLARE SUB getpos ()
DECLARE SUB ResetMouse ()
DECLARE SUB MoveTo (xx%, yy%)

'//Button Declarations
DIM SHARED Button.id(1 TO 50)
DIM SHARED Button.xStart(1 TO 50)
DIM SHARED Button.yStart(1 TO 50)
DIM SHARED Button.xEnd(1 TO 50)
DIM SHARED Button.yEnd(1 TO 50)
DIM SHARED Button.Text$(1 TO 50)
DIM SHARED Button.Counter



'//Mouse Declarations
TYPE registers
   ax AS INTEGER
   bx AS INTEGER
   cx AS INTEGER
   dx AS INTEGER
   bp AS INTEGER
   si AS INTEGER
   di AS INTEGER
   flags AS INTEGER
   ds AS INTEGER
   es AS INTEGER
END TYPE
TYPE Mouse
   Button AS INTEGER
   x AS INTEGER
   Y AS INTEGER
END TYPE
DIM SHARED muis AS Mouse

SCREEN 12
CLS
PAINT (1, 1), 7

'Load Font
a$ = "c:\"         '//Change to directory you unzipped to
fopen a$ + "SmallSys.qbf", 1

'Load Buttons
Button 1, 120, 125, 180, 150, "Button1"
Button 2, 120, 155, 180, 180, "Button2"
Button 3, 120, 185, 180, 210, "Button3"


ResetMouse
show
           
'--------------Program Start------------
DO
getpos
IF muis.Button = 1 THEN

'Check For Button Click
FOR counter = 1 TO Button.Counter
IF muis.x > Button.xStart(counter) AND muis.x < Button.xEnd(counter) AND muis.Y > Button.yStart(counter) AND muis.Y < Button.yEnd(counter) THEN

Button.Animate (counter)

SELECT CASE counter
    CASE IS = 1
        GOSUB Button1:
    CASE IS = 2
        GOSUB Button2:
    CASE IS = 3
        GOSUB Button3:
END SELECT

END IF
NEXT counter


END IF

LOOP


'Actions ....OnClick Button
Button1:
LOCATE 1, 1
PRINT "Button1 Clicked"
RETURN

Button2:
LOCATE 1, 1
PRINT "Button2 Clicked"
RETURN

Button3:
LOCATE 1, 1
PRINT "Button3 Clicked"
RETURN

SUB Button (id!, xStart!, yStart!, xEnd!, yEnd!, Text$)

Button.Counter = Button.Counter + 1
Button.id(id) = id
Button.xStart(id) = xStart
Button.yStart(id) = yStart
Button.xEnd(id) = xEnd
Button.yEnd(id) = yEnd
Button.Text$(id) = Text$
Space = 3


'Button
LINE (xStart, yStart)-(xEnd, yEnd), 0, B
LINE (xStart + Space, yStart + Space)-(xEnd - Space, yEnd - Space), 7, BF
FOR z = 1 TO Space - 1
LINE (xStart + z, yStart + z)-(xStart + z, yEnd - z), 15
LINE (xStart + z, yStart + z)-(xEnd - z, yStart + z), 15
LINE (xEnd - z, yStart + z)-(xEnd - z, yEnd - z), 8
LINE (xStart + z, yEnd - z)-(xEnd - z, yEnd - z), 8
NEXT z

fprint Button.Text$(id), Button.xStart(id) + 8, Button.yStart(id) + 4, 0, 1

END SUB

SUB Button.Animate (id!)

xStart = Button.xStart(id!)
yStart = Button.yStart(id!)
xEnd = Button.xEnd(id!)
yEnd = Button.yEnd(id!)
Space = 3

hide
LINE (xStart, yStart)-(xEnd, yEnd), 0, B
LINE (xStart + Space, yStart + Space)-(xEnd - Space, yEnd - Space), 7, BF
FOR z = 1 TO Space - 1
LINE (xStart + z, yStart + z)-(xStart + z, yEnd - z), 8
LINE (xStart + z, yStart + z)-(xEnd - z, yStart + z), 8
LINE (xEnd - z, yStart + z)-(xEnd - z, yEnd - z), 15
LINE (xStart + z, yEnd - z)-(xEnd - z, yEnd - z), 15
NEXT z
fprint Button.Text$(id), Button.xStart(id) + 8, Button.yStart(id) + 5, 0, 1

show

WHILE (muis.Button = 1)
getpos
WEND

hide
LINE (xStart, yStart)-(xEnd, yEnd), 0, B
LINE (xStart + Space, yStart + Space)-(xEnd - Space, yEnd - Space), 7, BF
FOR z = 1 TO Space - 1
LINE (xStart + z, yStart + z)-(xStart + z, yEnd - z), 15
LINE (xStart + z, yStart + z)-(xEnd - z, yStart + z), 15
LINE (xEnd - z, yStart + z)-(xEnd - z, yEnd - z), 8
LINE (xStart + z, yEnd - z)-(xEnd - z, yEnd - z), 8
NEXT z

fprint Button.Text$(id), Button.xStart(id) + 8, Button.yStart(id) + 4, 0, 1

show

END SUB

SUB fopen (file$, file%)
  OPEN file$ FOR RANDOM AS file% LEN = 2
END SUB

SUB fprint (Text$, Textx, Texty, Colour%, file%)
  'lpi: lines per integer
  'fws: font word spacing
  'fls: font letter spacing
  'p% : pointer
 
  GET file%, 1, lpi%
  GET file%, 2, fws%
  GET file%, 3, fls%
  FOR count% = 1 TO LEN(Text$)
    m% = ASC(MID$(Text$, count%, 1)) - 29
    IF m% > 3 THEN
      GET file%, m%, a1%
      GET file%, m% + 1, a2%
      FOR n% = a1% TO a2% - 1 STEP lpi%
        FOR z% = 0 TO lpi% - 1
          GET file%, n% + z%, l%
          LINE (p% + Textx, (16 * z%) + Texty)-(p% + Textx, (16 * z%) + 15 + Texty), Colour%, , l%
        NEXT z%
        p% = p% + 1
      NEXT n%
      p% = p% + fls%
    ELSE
      p% = p% + fws%
    END IF
  NEXT count%
END SUB

SUB getpos
'get current mouse position and button status
CALL Mouse(3, muis.Button, muis.x, muis.Y)
END SUB

SUB hide
'hide mouse cursor shown with show
CALL Mouse(2, 0, 0, 0)
END SUB

SUB Mouse (a%, B%, c%, d%)
DIM ms AS registers
ms.ax = a%
ms.bx = B%
ms.cx = c%
ms.dx = d%
CALL interrupt(51, ms, ms)

a% = ms.ax
B% = ms.bx
c% = ms.cx
d% = ms.dx
END SUB

SUB ResetMouse
'sets mouse in middle of screen and hide it
CALL Mouse(0, 0, 0, 0)
END SUB

SUB show
'show hardware mouse cursor
CALL Mouse(1, 0, 0, 0)
END SUB

